/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.system.controller.SnCardController
 *  com.ruoyi.system.domain.SnCard
 *  com.ruoyi.system.service.ISnCardService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.domain.SnCard;
import com.ruoyi.system.service.ISnCardService;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/SnCard"})
public class SnCardController
extends BaseController {
    @Autowired
    private ISnCardService snCardService;

    @RequiresPermissions(value={"system:SnCard:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SnCard snCard) {
        this.startPage();
        List list = this.snCardService.selectSnCardList(snCard);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:SnCard:export"})
    @Log(title="卡密", businessType=BusinessType.EXPORT)
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SnCard snCard) {
        List list = this.snCardService.selectSnCardList(snCard);
        ExcelUtil util = new ExcelUtil(SnCard.class);
        util.exportExcel(response, list, "卡密数据");
    }

    @RequiresPermissions(value={"system:SnCard:query"})
    @GetMapping(value={"/{cardId}"})
    public AjaxResult getInfo(@PathVariable(value="cardId") Long cardId) {
        return this.success((Object)this.snCardService.selectSnCardByCardId(cardId));
    }

    @RequiresPermissions(value={"system:SnCard:add"})
    @Log(title="卡密", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SnCard snCard) {
        if (snCard.getDealerId() == null) {
            return this.error("经销商ID不能为空");
        }
        if (snCard.getType() == null || snCard.getType() < 1) {
            return this.error("卡密数量有误");
        }
        if (snCard.getNumber() == null || snCard.getNumber() < 1) {
            return this.error("卡密数量有误");
        }
        return this.snCardService.insertSnCard(snCard);
    }

    @RequiresPermissions(value={"system:SnCard:edit"})
    @Log(title="卡密", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SnCard snCard) {
        return this.toAjax(this.snCardService.updateSnCard(snCard));
    }

    @RequiresPermissions(value={"system:SnCard:remove"})
    @Log(title="卡密", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{cardIds}"})
    public AjaxResult remove(@PathVariable Long[] cardIds) {
        return this.toAjax(this.snCardService.deleteSnCardByCardIds(cardIds));
    }
}

